Index: i18n/en.ts
===================================================================
--- i18n/en.ts	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ i18n/en.ts	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -111,64 +111,81 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
-        <location filename="../src/mainwindow.cpp" line="292"/>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
         <source>Unable to load translation language.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="159"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <source>New Task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Would you like to save changes in current task?</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <source>Task Open</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="173"/>
         <source>All Supported Formats</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="160"/>
-        <location filename="../src/mainwindow.cpp" line="161"/>
+        <location filename="../src/mainwindow.cpp" line="174"/>
+        <location filename="../src/mainwindow.cpp" line="175"/>
         <source>%1 Task Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
-        <location filename="../src/mainwindow.cpp" line="177"/>
+        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="196"/>
         <source>All Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>%1 Task File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Data error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>Solution error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>There was an error while solving the task.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="292"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
         <source>Language will be autodetected on next application start.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -177,7 +194,6 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
-        <source>Travelling salesman problem</source>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Application Close</source>
         <translation type="unfinished"></translation>
     </message>
@@ -267,6 +283,6 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="558"/>
-        <location filename="../ui/mainwindow.ui" line="571"/>
+        <location filename="../ui/mainwindow.ce.ui" line="559"/>
+        <location filename="../ui/mainwindow.ui" line="572"/>
         <source>&amp;Save</source>
         <translation type="unfinished"></translation>
@@ -279,4 +295,10 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem[*]</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="262"/>
         <location filename="../ui/mainwindow.ui" line="240"/>
@@ -297,236 +319,259 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="349"/>
-        <location filename="../ui/mainwindow.ui" line="362"/>
+        <location filename="../ui/mainwindow.ce.ui" line="350"/>
+        <location filename="../ui/mainwindow.ui" line="363"/>
         <source>Solution st&amp;eps</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="352"/>
-        <location filename="../ui/mainwindow.ui" line="365"/>
+        <location filename="../ui/mainwindow.ce.ui" line="353"/>
+        <location filename="../ui/mainwindow.ui" line="366"/>
         <source>Save solution steps</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="355"/>
-        <location filename="../ui/mainwindow.ui" line="368"/>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="369"/>
         <source>Save solution steps only</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="363"/>
-        <location filename="../ui/mainwindow.ui" line="376"/>
+        <location filename="../ui/mainwindow.ce.ui" line="364"/>
+        <location filename="../ui/mainwindow.ui" line="377"/>
         <source>Solution &amp;graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="366"/>
-        <location filename="../ui/mainwindow.ui" line="379"/>
+        <location filename="../ui/mainwindow.ce.ui" line="367"/>
+        <location filename="../ui/mainwindow.ui" line="380"/>
         <source>Save solution graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="369"/>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ce.ui" line="370"/>
+        <location filename="../ui/mainwindow.ui" line="383"/>
         <source>Save solution graph only</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="390"/>
+        <location filename="../ui/mainwindow.ce.ui" line="378"/>
+        <location filename="../ui/mainwindow.ui" line="391"/>
         <source>&amp;Solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="393"/>
+        <location filename="../ui/mainwindow.ce.ui" line="381"/>
+        <location filename="../ui/mainwindow.ui" line="394"/>
         <source>Save solution</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="396"/>
+        <location filename="../ui/mainwindow.ce.ui" line="384"/>
+        <location filename="../ui/mainwindow.ui" line="397"/>
         <source>Save solution steps and graph</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="392"/>
-        <location filename="../ui/mainwindow.ui" line="405"/>
+        <location filename="../ui/mainwindow.ce.ui" line="393"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>&amp;New</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="408"/>
+        <location filename="../ui/mainwindow.ce.ui" line="396"/>
+        <location filename="../ui/mainwindow.ui" line="409"/>
         <source>New</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="411"/>
+        <location filename="../ui/mainwindow.ce.ui" line="399"/>
+        <location filename="../ui/mainwindow.ui" line="412"/>
         <source>New task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="401"/>
-        <location filename="../ui/mainwindow.ui" line="414"/>
+        <location filename="../ui/mainwindow.ce.ui" line="402"/>
+        <location filename="../ui/mainwindow.ui" line="415"/>
         <source>Create new task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="404"/>
-        <location filename="../ui/mainwindow.ui" line="417"/>
+        <location filename="../ui/mainwindow.ce.ui" line="405"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>Ctrl+N</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="413"/>
-        <location filename="../ui/mainwindow.ui" line="426"/>
+        <location filename="../ui/mainwindow.ce.ui" line="414"/>
+        <location filename="../ui/mainwindow.ui" line="427"/>
         <source>&amp;Open...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="416"/>
-        <location filename="../ui/mainwindow.ui" line="429"/>
+        <location filename="../ui/mainwindow.ce.ui" line="417"/>
+        <location filename="../ui/mainwindow.ui" line="430"/>
         <source>Open...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="432"/>
+        <location filename="../ui/mainwindow.ce.ui" line="420"/>
+        <location filename="../ui/mainwindow.ui" line="433"/>
         <source>Open task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="435"/>
+        <location filename="../ui/mainwindow.ce.ui" line="423"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>Open saved task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="425"/>
-        <location filename="../ui/mainwindow.ui" line="438"/>
+        <location filename="../ui/mainwindow.ce.ui" line="426"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>Ctrl+O</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="447"/>
+        <location filename="../ui/mainwindow.ce.ui" line="435"/>
+        <location filename="../ui/mainwindow.ui" line="448"/>
         <source>&amp;Preferences...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="437"/>
-        <location filename="../ui/mainwindow.ui" line="450"/>
+        <location filename="../ui/mainwindow.ce.ui" line="438"/>
+        <location filename="../ui/mainwindow.ui" line="451"/>
         <source>Preferences...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="440"/>
-        <location filename="../ui/mainwindow.ui" line="453"/>
+        <location filename="../ui/mainwindow.ce.ui" line="441"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>Application preferences</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="452"/>
-        <location filename="../ui/mainwindow.ui" line="465"/>
+        <location filename="../ui/mainwindow.ce.ui" line="453"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>&amp;Contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="455"/>
-        <location filename="../ui/mainwindow.ui" line="468"/>
+        <location filename="../ui/mainwindow.ce.ui" line="456"/>
+        <location filename="../ui/mainwindow.ui" line="469"/>
         <source>Open help contents</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="480"/>
+        <location filename="../ui/mainwindow.ce.ui" line="468"/>
+        <location filename="../ui/mainwindow.ui" line="481"/>
         <source>&amp;Context help</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="470"/>
-        <location filename="../ui/mainwindow.ui" line="483"/>
+        <location filename="../ui/mainwindow.ce.ui" line="471"/>
+        <location filename="../ui/mainwindow.ui" line="484"/>
         <source>Open context help</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="479"/>
-        <location filename="../ui/mainwindow.ui" line="492"/>
+        <location filename="../ui/mainwindow.ce.ui" line="480"/>
+        <location filename="../ui/mainwindow.ui" line="493"/>
         <source>&amp;About...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="482"/>
-        <location filename="../ui/mainwindow.ui" line="495"/>
+        <location filename="../ui/mainwindow.ce.ui" line="483"/>
+        <location filename="../ui/mainwindow.ui" line="496"/>
         <source>About...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="485"/>
-        <location filename="../ui/mainwindow.ui" line="498"/>
+        <location filename="../ui/mainwindow.ce.ui" line="486"/>
+        <location filename="../ui/mainwindow.ui" line="499"/>
         <source>About application</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="494"/>
-        <location filename="../ui/mainwindow.ui" line="507"/>
+        <location filename="../ui/mainwindow.ce.ui" line="495"/>
+        <location filename="../ui/mainwindow.ui" line="508"/>
         <source>E&amp;xit</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="497"/>
-        <location filename="../ui/mainwindow.ui" line="510"/>
+        <location filename="../ui/mainwindow.ce.ui" line="498"/>
+        <location filename="../ui/mainwindow.ui" line="511"/>
         <source>Exit application</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="506"/>
-        <location filename="../ui/mainwindow.ui" line="519"/>
+        <location filename="../ui/mainwindow.ce.ui" line="507"/>
+        <location filename="../ui/mainwindow.ui" line="520"/>
         <source>&amp;Task...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="509"/>
-        <location filename="../ui/mainwindow.ui" line="522"/>
+        <location filename="../ui/mainwindow.ce.ui" line="510"/>
+        <location filename="../ui/mainwindow.ui" line="523"/>
         <source>Task...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="512"/>
-        <location filename="../ui/mainwindow.ce.ui" line="561"/>
-        <location filename="../ui/mainwindow.ui" line="525"/>
-        <location filename="../ui/mainwindow.ui" line="577"/>
+        <location filename="../ui/mainwindow.ce.ui" line="513"/>
+        <location filename="../ui/mainwindow.ce.ui" line="562"/>
+        <location filename="../ui/mainwindow.ui" line="526"/>
+        <location filename="../ui/mainwindow.ui" line="578"/>
         <source>Save task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="515"/>
-        <location filename="../ui/mainwindow.ui" line="528"/>
+        <location filename="../ui/mainwindow.ce.ui" line="516"/>
+        <location filename="../ui/mainwindow.ui" line="529"/>
         <source>Save task to file</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="518"/>
-        <location filename="../ui/mainwindow.ui" line="531"/>
+        <location filename="../ui/mainwindow.ce.ui" line="519"/>
+        <location filename="../ui/mainwindow.ui" line="532"/>
         <source>Ctrl+S</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="529"/>
-        <location filename="../ui/mainwindow.ui" line="542"/>
+        <location filename="../ui/mainwindow.ce.ui" line="530"/>
+        <location filename="../ui/mainwindow.ui" line="543"/>
         <source>&amp;Autodetect</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="546"/>
+        <location filename="../ui/mainwindow.ce.ui" line="547"/>
         <source>English</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="564"/>
-        <location filename="../ui/mainwindow.ui" line="580"/>
+        <location filename="../ui/mainwindow.ce.ui" line="565"/>
+        <location filename="../ui/mainwindow.ui" line="581"/>
         <source>Save current task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="590"/>
+        <source>About &amp;Qt...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="577"/>
+        <location filename="../ui/mainwindow.ui" line="593"/>
+        <source>About Qt...</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="580"/>
+        <source>About Qt</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="583"/>
+        <location filename="../ui/mainwindow.ui" line="596"/>
+        <source>About Qt library</source>
         <translation type="unfinished"></translation>
     </message>
@@ -544,42 +589,42 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="333"/>
+        <location filename="../ui/mainwindow.ui" line="334"/>
         <source>P&amp;rint setup...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="336"/>
+        <location filename="../ui/mainwindow.ui" line="337"/>
         <source>Setup printing</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="349"/>
         <source>&amp;Print...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="352"/>
         <source>Print solution results</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="355"/>
         <source>Ctrl+P</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="575"/>
         <source>Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="532"/>
-        <location filename="../ui/mainwindow.ui" line="545"/>
+        <location filename="../ui/mainwindow.ce.ui" line="533"/>
+        <location filename="../ui/mainwindow.ui" line="546"/>
         <source>Detect language automatically</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="535"/>
-        <location filename="../ui/mainwindow.ui" line="548"/>
+        <location filename="../ui/mainwindow.ce.ui" line="536"/>
+        <location filename="../ui/mainwindow.ui" line="549"/>
         <source>Detect language automatically based on regional settings</source>
         <translation type="unfinished"></translation>
Index: i18n/ru.ts
===================================================================
--- i18n/ru.ts	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ i18n/ru.ts	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -113,64 +113,81 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
-        <location filename="../src/mainwindow.cpp" line="292"/>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>Language change</source>
         <translation>Смена языка</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
         <source>Unable to load translation language.</source>
         <translation>Невозможно загрузить перевод.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="159"/>
+        <location filename="../src/mainwindow.cpp" line="173"/>
         <source>All Supported Formats</source>
         <translation>Все поддерживаемые форматы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
-        <location filename="../src/mainwindow.cpp" line="177"/>
+        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="196"/>
         <source>All Files</source>
         <translation>Все файлы</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="160"/>
-        <location filename="../src/mainwindow.cpp" line="161"/>
+        <location filename="../src/mainwindow.cpp" line="174"/>
+        <location filename="../src/mainwindow.cpp" line="175"/>
         <source>%1 Task Files</source>
         <translation>Файлы задач %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <source>New Task</source>
+        <translation>Новая задача</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Would you like to save changes in current task?</source>
+        <translation>Желаете сохранить изменения в текущей задаче?</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <source>Task Open</source>
+        <translation>Открытие задания</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>%1 Task File</source>
         <translation>Файл задачи %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Data error</source>
         <translation>Ошибка в данных</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>Solution error</source>
         <translation>Ошибка при решении</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>There was an error while solving the task.</source>
         <translation>Во время решения задачи возникла ошибка.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="292"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Язык будет автоматически определен при следующем запуске приложения.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -181,8 +198,11 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Application Close</source>
+        <translation>Закрытие приложения</translation>
+    </message>
+    <message>
         <source>Travelling salesman problem</source>
-        <translation>Задача коммивояжера</translation>
+        <translation type="obsolete">Задача коммивояжера</translation>
     </message>
     <message>
@@ -271,6 +291,6 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="558"/>
-        <location filename="../ui/mainwindow.ui" line="571"/>
+        <location filename="../ui/mainwindow.ce.ui" line="559"/>
+        <location filename="../ui/mainwindow.ui" line="572"/>
         <source>&amp;Save</source>
         <translation>Со&amp;хранить</translation>
@@ -283,4 +303,10 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem[*]</source>
+        <translation>Задача коммивояжера[*]</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="262"/>
         <location filename="../ui/mainwindow.ui" line="240"/>
@@ -301,237 +327,260 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="349"/>
-        <location filename="../ui/mainwindow.ui" line="362"/>
+        <location filename="../ui/mainwindow.ce.ui" line="350"/>
+        <location filename="../ui/mainwindow.ui" line="363"/>
         <source>Solution st&amp;eps</source>
         <translation>&amp;Ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="352"/>
-        <location filename="../ui/mainwindow.ui" line="365"/>
+        <location filename="../ui/mainwindow.ce.ui" line="353"/>
+        <location filename="../ui/mainwindow.ui" line="366"/>
         <source>Save solution steps</source>
         <translation>Сохранить ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="355"/>
-        <location filename="../ui/mainwindow.ui" line="368"/>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="369"/>
         <source>Save solution steps only</source>
         <translation>Сохранить только ход решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="363"/>
-        <location filename="../ui/mainwindow.ui" line="376"/>
+        <location filename="../ui/mainwindow.ce.ui" line="364"/>
+        <location filename="../ui/mainwindow.ui" line="377"/>
         <source>Solution &amp;graph</source>
         <translation>&amp;Граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="366"/>
-        <location filename="../ui/mainwindow.ui" line="379"/>
+        <location filename="../ui/mainwindow.ce.ui" line="367"/>
+        <location filename="../ui/mainwindow.ui" line="380"/>
         <source>Save solution graph</source>
         <translation>Сохранить граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="369"/>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ce.ui" line="370"/>
+        <location filename="../ui/mainwindow.ui" line="383"/>
         <source>Save solution graph only</source>
         <translation>Сохранить только граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="390"/>
+        <location filename="../ui/mainwindow.ce.ui" line="378"/>
+        <location filename="../ui/mainwindow.ui" line="391"/>
         <source>&amp;Solution</source>
         <translation>&amp;Решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="393"/>
+        <location filename="../ui/mainwindow.ce.ui" line="381"/>
+        <location filename="../ui/mainwindow.ui" line="394"/>
         <source>Save solution</source>
         <translation>Сохранить решение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="396"/>
+        <location filename="../ui/mainwindow.ce.ui" line="384"/>
+        <location filename="../ui/mainwindow.ui" line="397"/>
         <source>Save solution steps and graph</source>
         <translation>Сохранить ход и граф решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="392"/>
-        <location filename="../ui/mainwindow.ui" line="405"/>
+        <location filename="../ui/mainwindow.ce.ui" line="393"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>&amp;New</source>
         <translation>&amp;Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="408"/>
+        <location filename="../ui/mainwindow.ce.ui" line="396"/>
+        <location filename="../ui/mainwindow.ui" line="409"/>
         <source>New</source>
         <translation>Создать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="411"/>
+        <location filename="../ui/mainwindow.ce.ui" line="399"/>
+        <location filename="../ui/mainwindow.ui" line="412"/>
         <source>New task</source>
         <translation>Создать задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="401"/>
-        <location filename="../ui/mainwindow.ui" line="414"/>
+        <location filename="../ui/mainwindow.ce.ui" line="402"/>
+        <location filename="../ui/mainwindow.ui" line="415"/>
         <source>Create new task</source>
         <translation>Создать новую задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="404"/>
-        <location filename="../ui/mainwindow.ui" line="417"/>
+        <location filename="../ui/mainwindow.ce.ui" line="405"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="413"/>
-        <location filename="../ui/mainwindow.ui" line="426"/>
+        <location filename="../ui/mainwindow.ce.ui" line="414"/>
+        <location filename="../ui/mainwindow.ui" line="427"/>
         <source>&amp;Open...</source>
         <translation>&amp;Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="416"/>
-        <location filename="../ui/mainwindow.ui" line="429"/>
+        <location filename="../ui/mainwindow.ce.ui" line="417"/>
+        <location filename="../ui/mainwindow.ui" line="430"/>
         <source>Open...</source>
         <translation>Открыть...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="432"/>
+        <location filename="../ui/mainwindow.ce.ui" line="420"/>
+        <location filename="../ui/mainwindow.ui" line="433"/>
         <source>Open task</source>
         <translation>Открыть задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="435"/>
+        <location filename="../ui/mainwindow.ce.ui" line="423"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>Open saved task</source>
         <translation>Открыть сохраненное условие задачи</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="425"/>
-        <location filename="../ui/mainwindow.ui" line="438"/>
+        <location filename="../ui/mainwindow.ce.ui" line="426"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="447"/>
+        <location filename="../ui/mainwindow.ce.ui" line="435"/>
+        <location filename="../ui/mainwindow.ui" line="448"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="437"/>
-        <location filename="../ui/mainwindow.ui" line="450"/>
+        <location filename="../ui/mainwindow.ce.ui" line="438"/>
+        <location filename="../ui/mainwindow.ui" line="451"/>
         <source>Preferences...</source>
         <translation>Параметры...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="440"/>
-        <location filename="../ui/mainwindow.ui" line="453"/>
+        <location filename="../ui/mainwindow.ce.ui" line="441"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>Application preferences</source>
         <translation>Настройка параметров программмы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="452"/>
-        <location filename="../ui/mainwindow.ui" line="465"/>
+        <location filename="../ui/mainwindow.ce.ui" line="453"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>&amp;Contents</source>
         <translation>&amp;Содежание</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="455"/>
-        <location filename="../ui/mainwindow.ui" line="468"/>
+        <location filename="../ui/mainwindow.ce.ui" line="456"/>
+        <location filename="../ui/mainwindow.ui" line="469"/>
         <source>Open help contents</source>
         <translation>Вызвать справку программы</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="480"/>
+        <location filename="../ui/mainwindow.ce.ui" line="468"/>
+        <location filename="../ui/mainwindow.ui" line="481"/>
         <source>&amp;Context help</source>
         <translation>&amp;Контекстная справка</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="470"/>
-        <location filename="../ui/mainwindow.ui" line="483"/>
+        <location filename="../ui/mainwindow.ce.ui" line="471"/>
+        <location filename="../ui/mainwindow.ui" line="484"/>
         <source>Open context help</source>
         <translation>Вызвать контекстную справку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="479"/>
-        <location filename="../ui/mainwindow.ui" line="492"/>
+        <location filename="../ui/mainwindow.ce.ui" line="480"/>
+        <location filename="../ui/mainwindow.ui" line="493"/>
         <source>&amp;About...</source>
         <translation>&amp;Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="482"/>
-        <location filename="../ui/mainwindow.ui" line="495"/>
+        <location filename="../ui/mainwindow.ce.ui" line="483"/>
+        <location filename="../ui/mainwindow.ui" line="496"/>
         <source>About...</source>
         <translation>Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="485"/>
-        <location filename="../ui/mainwindow.ui" line="498"/>
+        <location filename="../ui/mainwindow.ce.ui" line="486"/>
+        <location filename="../ui/mainwindow.ui" line="499"/>
         <source>About application</source>
         <translation>О программе</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="494"/>
-        <location filename="../ui/mainwindow.ui" line="507"/>
+        <location filename="../ui/mainwindow.ce.ui" line="495"/>
+        <location filename="../ui/mainwindow.ui" line="508"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ыход</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="497"/>
-        <location filename="../ui/mainwindow.ui" line="510"/>
+        <location filename="../ui/mainwindow.ce.ui" line="498"/>
+        <location filename="../ui/mainwindow.ui" line="511"/>
         <source>Exit application</source>
         <translation>Выйти из приложения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="506"/>
-        <location filename="../ui/mainwindow.ui" line="519"/>
+        <location filename="../ui/mainwindow.ce.ui" line="507"/>
+        <location filename="../ui/mainwindow.ui" line="520"/>
         <source>&amp;Task...</source>
         <translation>&amp;Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="509"/>
-        <location filename="../ui/mainwindow.ui" line="522"/>
+        <location filename="../ui/mainwindow.ce.ui" line="510"/>
+        <location filename="../ui/mainwindow.ui" line="523"/>
         <source>Task...</source>
         <translation>Задачу...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="512"/>
-        <location filename="../ui/mainwindow.ce.ui" line="561"/>
-        <location filename="../ui/mainwindow.ui" line="525"/>
-        <location filename="../ui/mainwindow.ui" line="577"/>
+        <location filename="../ui/mainwindow.ce.ui" line="513"/>
+        <location filename="../ui/mainwindow.ce.ui" line="562"/>
+        <location filename="../ui/mainwindow.ui" line="526"/>
+        <location filename="../ui/mainwindow.ui" line="578"/>
         <source>Save task</source>
         <translation>Сохранить задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="515"/>
-        <location filename="../ui/mainwindow.ui" line="528"/>
+        <location filename="../ui/mainwindow.ce.ui" line="516"/>
+        <location filename="../ui/mainwindow.ui" line="529"/>
         <source>Save task to file</source>
         <translation>Сохранить условие задачи в файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="518"/>
-        <location filename="../ui/mainwindow.ui" line="531"/>
+        <location filename="../ui/mainwindow.ce.ui" line="519"/>
+        <location filename="../ui/mainwindow.ui" line="532"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="529"/>
-        <location filename="../ui/mainwindow.ui" line="542"/>
+        <location filename="../ui/mainwindow.ce.ui" line="530"/>
+        <location filename="../ui/mainwindow.ui" line="543"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автоопределение</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="546"/>
+        <location filename="../ui/mainwindow.ce.ui" line="547"/>
         <source>English</source>
         <translation>Английский</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="564"/>
-        <location filename="../ui/mainwindow.ui" line="580"/>
+        <location filename="../ui/mainwindow.ce.ui" line="565"/>
+        <location filename="../ui/mainwindow.ui" line="581"/>
         <source>Save current task</source>
         <translation>Сохранить текущую задачу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="590"/>
+        <source>About &amp;Qt...</source>
+        <translation>Про &amp;Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="577"/>
+        <location filename="../ui/mainwindow.ui" line="593"/>
+        <source>About Qt...</source>
+        <translation>Про Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="580"/>
+        <source>About Qt</source>
+        <translation>Про Qt</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="583"/>
+        <location filename="../ui/mainwindow.ui" line="596"/>
+        <source>About Qt library</source>
+        <translation>Про библиотеку Qt</translation>
     </message>
     <message>
@@ -548,42 +597,42 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="333"/>
+        <location filename="../ui/mainwindow.ui" line="334"/>
         <source>P&amp;rint setup...</source>
         <translation>&amp;Настройка печати...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="336"/>
+        <location filename="../ui/mainwindow.ui" line="337"/>
         <source>Setup printing</source>
         <translation>Настроить печать</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="349"/>
         <source>&amp;Print...</source>
         <translation>&amp;Печать...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="352"/>
         <source>Print solution results</source>
         <translation>Распечатать результаты решения</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="355"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="575"/>
         <source>Save</source>
         <translation>Сохранить</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="532"/>
-        <location filename="../ui/mainwindow.ui" line="545"/>
+        <location filename="../ui/mainwindow.ce.ui" line="533"/>
+        <location filename="../ui/mainwindow.ui" line="546"/>
         <source>Detect language automatically</source>
         <translation>Определять язык автоматически</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="535"/>
-        <location filename="../ui/mainwindow.ui" line="548"/>
+        <location filename="../ui/mainwindow.ce.ui" line="536"/>
+        <location filename="../ui/mainwindow.ui" line="549"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Определять язык автоматически, основываясь на региональных настройках</translation>
Index: i18n/uk.ts
===================================================================
--- i18n/uk.ts	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ i18n/uk.ts	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -137,62 +137,60 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="333"/>
+        <location filename="../ui/mainwindow.ui" line="334"/>
         <source>P&amp;rint setup...</source>
         <translation>&amp;Налагодження друку...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="336"/>
+        <location filename="../ui/mainwindow.ui" line="337"/>
         <source>Setup printing</source>
         <translation>Налагодити друк</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="349"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="351"/>
+        <location filename="../ui/mainwindow.ui" line="352"/>
         <source>Print solution results</source>
         <translation>Роздрукувати результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="354"/>
+        <location filename="../ui/mainwindow.ui" line="355"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="575"/>
         <source>Save</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="532"/>
-        <location filename="../ui/mainwindow.ui" line="545"/>
+        <location filename="../ui/mainwindow.ce.ui" line="533"/>
+        <location filename="../ui/mainwindow.ui" line="546"/>
         <source>Detect language automatically</source>
         <translation>Визначати мову автоматично</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="535"/>
-        <location filename="../ui/mainwindow.ui" line="548"/>
+        <location filename="../ui/mainwindow.ce.ui" line="536"/>
+        <location filename="../ui/mainwindow.ui" line="549"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Визначати мову автоматично, використовуючи регіональні стандарти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="518"/>
-        <location filename="../ui/mainwindow.ui" line="531"/>
+        <location filename="../ui/mainwindow.ce.ui" line="519"/>
+        <location filename="../ui/mainwindow.ui" line="532"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="404"/>
-        <location filename="../ui/mainwindow.ui" line="417"/>
+        <location filename="../ui/mainwindow.ce.ui" line="405"/>
+        <location filename="../ui/mainwindow.ui" line="418"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="17"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
         <source>Travelling salesman problem</source>
-        <translation>Задача комівояжера</translation>
+        <translation type="obsolete">Задача комівояжера</translation>
     </message>
     <message>
@@ -269,6 +267,6 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="558"/>
-        <location filename="../ui/mainwindow.ui" line="571"/>
+        <location filename="../ui/mainwindow.ce.ui" line="559"/>
+        <location filename="../ui/mainwindow.ui" line="572"/>
         <source>&amp;Save</source>
         <translation>&amp;Зберегти</translation>
@@ -281,4 +279,10 @@
     </message>
     <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem[*]</source>
+        <translation>Задача комівояжера[*]</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="262"/>
         <location filename="../ui/mainwindow.ui" line="240"/>
@@ -299,287 +303,327 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="349"/>
-        <location filename="../ui/mainwindow.ui" line="362"/>
+        <location filename="../ui/mainwindow.ce.ui" line="350"/>
+        <location filename="../ui/mainwindow.ui" line="363"/>
         <source>Solution st&amp;eps</source>
         <translation>&amp;Хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="352"/>
-        <location filename="../ui/mainwindow.ui" line="365"/>
+        <location filename="../ui/mainwindow.ce.ui" line="353"/>
+        <location filename="../ui/mainwindow.ui" line="366"/>
         <source>Save solution steps</source>
         <translation>Зберегти хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="355"/>
-        <location filename="../ui/mainwindow.ui" line="368"/>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="369"/>
         <source>Save solution steps only</source>
         <translation>Зберегти тільки хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="363"/>
-        <location filename="../ui/mainwindow.ui" line="376"/>
+        <location filename="../ui/mainwindow.ce.ui" line="364"/>
+        <location filename="../ui/mainwindow.ui" line="377"/>
         <source>Solution &amp;graph</source>
         <translation>&amp;Граф розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="366"/>
-        <location filename="../ui/mainwindow.ui" line="379"/>
+        <location filename="../ui/mainwindow.ce.ui" line="367"/>
+        <location filename="../ui/mainwindow.ui" line="380"/>
         <source>Save solution graph</source>
         <translation>Зберегти граф розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="369"/>
-        <location filename="../ui/mainwindow.ui" line="382"/>
+        <location filename="../ui/mainwindow.ce.ui" line="370"/>
+        <location filename="../ui/mainwindow.ui" line="383"/>
         <source>Save solution graph only</source>
         <translation>Зберегти тільки граф розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="390"/>
+        <location filename="../ui/mainwindow.ce.ui" line="378"/>
+        <location filename="../ui/mainwindow.ui" line="391"/>
         <source>&amp;Solution</source>
         <translation>&amp;Розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="393"/>
+        <location filename="../ui/mainwindow.ce.ui" line="381"/>
+        <location filename="../ui/mainwindow.ui" line="394"/>
         <source>Save solution</source>
         <translation>Зберегти розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="396"/>
+        <location filename="../ui/mainwindow.ce.ui" line="384"/>
+        <location filename="../ui/mainwindow.ui" line="397"/>
         <source>Save solution steps and graph</source>
         <translation>Зберегти хід та граф розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="392"/>
-        <location filename="../ui/mainwindow.ui" line="405"/>
+        <location filename="../ui/mainwindow.ce.ui" line="393"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>&amp;New</source>
         <translation>&amp;Створити</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="408"/>
+        <location filename="../ui/mainwindow.ce.ui" line="396"/>
+        <location filename="../ui/mainwindow.ui" line="409"/>
         <source>New</source>
         <translation>Створити</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="411"/>
+        <location filename="../ui/mainwindow.ce.ui" line="399"/>
+        <location filename="../ui/mainwindow.ui" line="412"/>
         <source>New task</source>
         <translation>Нове завдання</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="401"/>
-        <location filename="../ui/mainwindow.ui" line="414"/>
+        <location filename="../ui/mainwindow.ce.ui" line="402"/>
+        <location filename="../ui/mainwindow.ui" line="415"/>
         <source>Create new task</source>
         <translation>Створити нове завдання</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="413"/>
-        <location filename="../ui/mainwindow.ui" line="426"/>
+        <location filename="../ui/mainwindow.ce.ui" line="414"/>
+        <location filename="../ui/mainwindow.ui" line="427"/>
         <source>&amp;Open...</source>
         <translation>&amp;Відкрити...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="416"/>
-        <location filename="../ui/mainwindow.ui" line="429"/>
+        <location filename="../ui/mainwindow.ce.ui" line="417"/>
+        <location filename="../ui/mainwindow.ui" line="430"/>
         <source>Open...</source>
         <translation>Відкрити...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="432"/>
+        <location filename="../ui/mainwindow.ce.ui" line="420"/>
+        <location filename="../ui/mainwindow.ui" line="433"/>
         <source>Open task</source>
         <translation>Відкрити завдання</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="435"/>
+        <location filename="../ui/mainwindow.ce.ui" line="423"/>
+        <location filename="../ui/mainwindow.ui" line="436"/>
         <source>Open saved task</source>
         <translation>Відкрити збережене завдання</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="425"/>
-        <location filename="../ui/mainwindow.ui" line="438"/>
+        <location filename="../ui/mainwindow.ce.ui" line="426"/>
+        <location filename="../ui/mainwindow.ui" line="439"/>
         <source>Ctrl+O</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="447"/>
+        <location filename="../ui/mainwindow.ce.ui" line="435"/>
+        <location filename="../ui/mainwindow.ui" line="448"/>
         <source>&amp;Preferences...</source>
         <translation>&amp;Параметри...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="437"/>
-        <location filename="../ui/mainwindow.ui" line="450"/>
+        <location filename="../ui/mainwindow.ce.ui" line="438"/>
+        <location filename="../ui/mainwindow.ui" line="451"/>
         <source>Preferences...</source>
         <translation>Параметри...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="440"/>
-        <location filename="../ui/mainwindow.ui" line="453"/>
+        <location filename="../ui/mainwindow.ce.ui" line="441"/>
+        <location filename="../ui/mainwindow.ui" line="454"/>
         <source>Application preferences</source>
         <translation>Параметри додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="452"/>
-        <location filename="../ui/mainwindow.ui" line="465"/>
+        <location filename="../ui/mainwindow.ce.ui" line="453"/>
+        <location filename="../ui/mainwindow.ui" line="466"/>
         <source>&amp;Contents</source>
         <translation>&amp;Зміст</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="455"/>
-        <location filename="../ui/mainwindow.ui" line="468"/>
+        <location filename="../ui/mainwindow.ce.ui" line="456"/>
+        <location filename="../ui/mainwindow.ui" line="469"/>
         <source>Open help contents</source>
         <translation>Відкрити зміст допомоги</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="480"/>
+        <location filename="../ui/mainwindow.ce.ui" line="468"/>
+        <location filename="../ui/mainwindow.ui" line="481"/>
         <source>&amp;Context help</source>
         <translation>&amp;Контекстна допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="470"/>
-        <location filename="../ui/mainwindow.ui" line="483"/>
+        <location filename="../ui/mainwindow.ce.ui" line="471"/>
+        <location filename="../ui/mainwindow.ui" line="484"/>
         <source>Open context help</source>
         <translation>Відкрити контекстну допомогу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="479"/>
-        <location filename="../ui/mainwindow.ui" line="492"/>
+        <location filename="../ui/mainwindow.ce.ui" line="480"/>
+        <location filename="../ui/mainwindow.ui" line="493"/>
         <source>&amp;About...</source>
         <translation>&amp;Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="482"/>
-        <location filename="../ui/mainwindow.ui" line="495"/>
+        <location filename="../ui/mainwindow.ce.ui" line="483"/>
+        <location filename="../ui/mainwindow.ui" line="496"/>
         <source>About...</source>
         <translation>Про...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="485"/>
-        <location filename="../ui/mainwindow.ui" line="498"/>
+        <location filename="../ui/mainwindow.ce.ui" line="486"/>
+        <location filename="../ui/mainwindow.ui" line="499"/>
         <source>About application</source>
         <translation>Про додаток</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="494"/>
-        <location filename="../ui/mainwindow.ui" line="507"/>
+        <location filename="../ui/mainwindow.ce.ui" line="495"/>
+        <location filename="../ui/mainwindow.ui" line="508"/>
         <source>E&amp;xit</source>
         <translation>В&amp;ихід</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="497"/>
-        <location filename="../ui/mainwindow.ui" line="510"/>
+        <location filename="../ui/mainwindow.ce.ui" line="498"/>
+        <location filename="../ui/mainwindow.ui" line="511"/>
         <source>Exit application</source>
         <translation>Вийти з додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="506"/>
-        <location filename="../ui/mainwindow.ui" line="519"/>
+        <location filename="../ui/mainwindow.ce.ui" line="507"/>
+        <location filename="../ui/mainwindow.ui" line="520"/>
         <source>&amp;Task...</source>
         <translation>&amp;Завдання...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="509"/>
-        <location filename="../ui/mainwindow.ui" line="522"/>
+        <location filename="../ui/mainwindow.ce.ui" line="510"/>
+        <location filename="../ui/mainwindow.ui" line="523"/>
         <source>Task...</source>
         <translation>Завдання...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="512"/>
-        <location filename="../ui/mainwindow.ce.ui" line="561"/>
-        <location filename="../ui/mainwindow.ui" line="525"/>
-        <location filename="../ui/mainwindow.ui" line="577"/>
+        <location filename="../ui/mainwindow.ce.ui" line="513"/>
+        <location filename="../ui/mainwindow.ce.ui" line="562"/>
+        <location filename="../ui/mainwindow.ui" line="526"/>
+        <location filename="../ui/mainwindow.ui" line="578"/>
         <source>Save task</source>
         <translation>Зберегти завдання</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="515"/>
-        <location filename="../ui/mainwindow.ui" line="528"/>
+        <location filename="../ui/mainwindow.ce.ui" line="516"/>
+        <location filename="../ui/mainwindow.ui" line="529"/>
         <source>Save task to file</source>
         <translation>Зберегти завдання до файлу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="529"/>
-        <location filename="../ui/mainwindow.ui" line="542"/>
+        <location filename="../ui/mainwindow.ce.ui" line="530"/>
+        <location filename="../ui/mainwindow.ui" line="543"/>
         <source>&amp;Autodetect</source>
         <translation>&amp;Автовизначення</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="546"/>
+        <location filename="../ui/mainwindow.ce.ui" line="547"/>
         <source>English</source>
         <translation>Англійська</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="564"/>
-        <location filename="../ui/mainwindow.ui" line="580"/>
+        <location filename="../ui/mainwindow.ce.ui" line="565"/>
+        <location filename="../ui/mainwindow.ui" line="581"/>
         <source>Save current task</source>
         <translation>Зберегти поточне завдання</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
-        <location filename="../src/mainwindow.cpp" line="292"/>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../ui/mainwindow.ce.ui" line="574"/>
+        <location filename="../ui/mainwindow.ui" line="590"/>
+        <source>About &amp;Qt...</source>
+        <translation>Про &amp;Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="577"/>
+        <location filename="../ui/mainwindow.ui" line="593"/>
+        <source>About Qt...</source>
+        <translation>Про Qt...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="580"/>
+        <source>About Qt</source>
+        <translation>Про Qt</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="583"/>
+        <location filename="../ui/mainwindow.ui" line="596"/>
+        <source>About Qt library</source>
+        <translation>Про бібліотеку Qt</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="127"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>Language change</source>
         <translation>Зміна мови</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="124"/>
+        <location filename="../src/mainwindow.cpp" line="127"/>
         <source>Unable to load translation language.</source>
         <translation>Неможливо завантажити переклад.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="159"/>
+        <location filename="../src/mainwindow.cpp" line="173"/>
         <source>All Supported Formats</source>
         <translation>Усі підтримувані формати</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="162"/>
-        <location filename="../src/mainwindow.cpp" line="177"/>
+        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="196"/>
         <source>All Files</source>
         <translation>Усі файли</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="160"/>
-        <location filename="../src/mainwindow.cpp" line="161"/>
+        <location filename="../src/mainwindow.cpp" line="174"/>
+        <location filename="../src/mainwindow.cpp" line="175"/>
         <source>%1 Task Files</source>
         <translation>Файли завдань %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="176"/>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <source>New Task</source>
+        <translation>Нова задача</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="155"/>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Would you like to save changes in current task?</source>
+        <translation>Бажаете зберегти зміни у поточній задачі?</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="166"/>
+        <source>Task Open</source>
+        <translation>Відкриття завдання</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="195"/>
         <source>%1 Task File</source>
         <translation>Файл завдання %1</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Data error</source>
         <translation>Помилка даних</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="228"/>
+        <location filename="../src/mainwindow.cpp" line="252"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>Solution error</source>
         <translation>Помилка розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="261"/>
         <source>There was an error while solving the task.</source>
         <translation>Під час розв&apos;язання задачі виникла помилка.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="292"/>
+        <location filename="../src/mainwindow.cpp" line="316"/>
         <source>Language will be autodetected on next application start.</source>
         <translation>Мову буде автоматично визначено при наступному запуску додатку.</translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="301"/>
+        <location filename="../src/mainwindow.cpp" line="325"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -589,4 +633,9 @@
 Вимкнути його?</translation>
     </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="339"/>
+        <source>Application Close</source>
+        <translation>Закриття додатку</translation>
+    </message>
 </context>
 <context>
Index: resources/tspsg.qrc
===================================================================
--- resources/tspsg.qrc	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ resources/tspsg.qrc	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -1,4 +1,5 @@
 <RCC>
   <qresource prefix="/images" >
+    <file>qtlogo-64.png</file>
     <file>About.bmp</file>
     <file>Icon.png</file>
Index: src/mainwindow.cpp
===================================================================
--- src/mainwindow.cpp	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ src/mainwindow.cpp	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -45,4 +45,5 @@
 	connect(actionSettingsLanguageAutodetect,SIGNAL(triggered(bool)),this,SLOT(actionSettingsLanguageAutodetectTriggered(bool)));
 	connect(groupSettingsLanguageList,SIGNAL(triggered(QAction *)),this,SLOT(groupSettingsLanguageListTriggered(QAction *)));
+	connect(actionHelpAboutQt,SIGNAL(triggered()),qApp,SLOT(aboutQt()));
 	connect(actionHelpAbout,SIGNAL(triggered()),this,SLOT(actionHelpAboutTriggered()));
 #ifndef Q_OS_WINCE
@@ -78,4 +79,6 @@
 	taskView->setModel(tspmodel);
 	connect(tspmodel,SIGNAL(numCitiesChanged(int)),this,SLOT(numCitiesChanged(int)));
+	connect(tspmodel,SIGNAL(dataChanged(const QModelIndex &, const QModelIndex &)),this,SLOT(dataChanged()));
+	connect(tspmodel,SIGNAL(layoutChanged()),this,SLOT(dataChanged()));
 #ifdef Q_OS_WINCE
 	taskView->resizeColumnsToContents();
@@ -149,9 +152,20 @@
 void MainWindow::actionFileNewTriggered()
 {
+	if (isWindowModified()) {
+int res = QMessageBox(QMessageBox::Warning,trUtf8("New Task"),trUtf8("Would you like to save changes in current task?"),QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel,this).exec();
+		if ((res == QMessageBox::Cancel) || ((res == QMessageBox::Yes) && !saveTask()))
+			return;
+	}
 	tspmodel->clear();
+	setWindowModified(false);
 }
 
 void MainWindow::actionFileOpenTriggered()
 {
+	if (isWindowModified()) {
+int res = QMessageBox(QMessageBox::Warning,trUtf8("Task Open"),trUtf8("Would you like to save changes in current task?"),QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel,this).exec();
+		if ((res == QMessageBox::Cancel) || ((res == QMessageBox::Yes) && !saveTask()))
+			return;
+	}
 QFileDialog od(this);
 	od.setAcceptMode(QFileDialog::AcceptOpen);
@@ -168,8 +182,13 @@
 		return;
 	tspmodel->loadTask(files.first());
+	setWindowModified(false);
 }
 
 void MainWindow::actionFileSaveTaskTriggered()
 {
+	saveTask();
+}
+
+bool MainWindow::saveTask() {
 QFileDialog sd(this);
 	sd.setAcceptMode(QFileDialog::AcceptSave);
@@ -179,9 +198,13 @@
 	sd.setDefaultSuffix("tspt");
 	if (sd.exec() != QDialog::Accepted)
-		return;
+		return false;
 QStringList files = sd.selectedFiles();
 	if (files.size() < 1)
-		return;
-	tspmodel->saveTask(files.first());
+		return false;
+	if (tspmodel->saveTask(files.first())) {
+		setWindowModified(false);
+		return true;
+	} else
+		return false;
 }
 
@@ -208,4 +231,5 @@
 {
 	tspmodel->randomize();
+	setWindowModified(true);
 #ifdef Q_OS_WINCE
 	taskView->resizeColumnsToContents();
@@ -244,6 +268,6 @@
 QString about = QString::fromUtf8("TSPSG - TSP Solver and Generator\n");
 about += QString::fromUtf8("    Copyright (C) 2007-%1 Lёppa <contacts[at]oleksii[dot]name>\n").arg(QDate::currentDate().toString("yyyy"));
-	about += "Qt library versions:\n";
-	about += QString::fromUtf8("    OS: %1\n").arg(OS);
+	about += QString::fromUtf8("Target OS: %1\n").arg(OS);
+	about += "Qt library:\n";
 	about += QString::fromUtf8("    Compile time: %1\n").arg(QT_VERSION_STR);
 	about += QString::fromUtf8("    Runtime: %1\n").arg(qVersion());
@@ -312,4 +336,11 @@
 void MainWindow::closeEvent(QCloseEvent *event)
 {
+	if (isWindowModified()) {
+int res = QMessageBox(QMessageBox::Warning,trUtf8("Application Close"),trUtf8("Would you like to save changes in current task?"),QMessageBox::Yes | QMessageBox::No | QMessageBox::Cancel,this).exec();
+		if ((res == QMessageBox::Cancel) || ((res == QMessageBox::Yes) && !saveTask())) {
+			event->ignore();
+			return;
+		}
+	}
 	settings->setValue("NumCities",spinCities->value());
 #ifndef Q_OS_WINCE
@@ -328,4 +359,9 @@
 }
 
+void MainWindow::dataChanged()
+{
+	setWindowModified(true);
+}
+
 void MainWindow::numCitiesChanged(int nCities)
 {
Index: src/mainwindow.h
===================================================================
--- src/mainwindow.h	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ src/mainwindow.h	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -49,4 +49,5 @@
 	void groupSettingsLanguageListTriggered(QAction *);
 	void actionHelpAboutTriggered();
+	void dataChanged();
 #ifndef Q_OS_WINCE
 	void actionFilePrintSetupTriggered();
@@ -63,4 +64,5 @@
 	bool loadLanguage(QString lang = "");
 	void loadLangList();
+	bool saveTask();
 };
 
Index: src/os.h
===================================================================
--- src/os.h	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ src/os.h	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -25,87 +25,95 @@
 #define OS_H
 
+#ifdef _WIN64
+	#define BITS " (64-bit)"
+#elif defined _WIN32
+	#define BITS " (32-bit)"
+#else
+	#define BITS ""
+#endif // BITS
+
 #ifdef Q_OS_AIX
-	#define OS "AIX"
+	#define OS "AIX"BITS
 	#define OSID quint8(1)
 #elif defined Q_OS_BSD4
-	#define OS "BSD 4.4"
+	#define OS "BSD 4.4"BITS
 	#define OSID quint8(2)
 #elif defined Q_OS_BSDI
-	#define OS "BSD/OS"
+	#define OS "BSD/OS"BITS
 	#define OSID quint8(3)
 #elif defined Q_OS_CYGWIN
-	#define OS "Cygwin"
+	#define OS "Cygwin"BITS
 	#define OSID quint8(4)
 #elif defined Q_OS_DARWIN
-	#define OS "Darwin OS"
+	#define OS "Darwin OS"BITS
 	#define OSID quint8(5)
 #elif defined Q_OS_DGUX
-	#define OS "DG/UX"
+	#define OS "DG/UX"BITS
 	#define OSID quint8(6)
 #elif defined Q_OS_DYNIX
-	#define OS "DYNIX/ptx"
+	#define OS "DYNIX/ptx"BITS
 	#define OSID quint8(7)
 #elif defined Q_OS_FREEBSD
-	#define OS "FreeBSD"
+	#define OS "FreeBSD"BITS
 	#define OSID quint8(8)
 #elif defined Q_OS_HPUX
-	#define OS "HP-UX"
+	#define OS "HP-UX"BITS
 	#define OSID quint8(9)
 #elif defined Q_OS_HURD
-	#define OS "GNU Hurd"
+	#define OS "GNU Hurd"BITS
 	#define OSID quint8(10)
 #elif defined Q_OS_IRIX
-	#define OS "SGI Irix"
+	#define OS "SGI Irix"BITS
 	#define OSID quint8(11)
 #elif defined Q_OS_LINUX
-	#define OS "Linux"
+	#define OS "Linux"BITS
 	#define OSID quint8(12)
 #elif defined Q_OS_LYNX
-	#define OS "LynxOS"
+	#define OS "LynxOS"BITS
 	#define OSID quint8(13)
 #elif defined Q_OS_MSDOS
-	#define OS "MS-DOS"
+	#define OS "MS-DOS"BITS
 	#define OSID quint8(14)
 #elif defined Q_OS_NETBSD
-	#define OS "NetBSD"
+	#define OS "NetBSD"BITS
 	#define OSID quint8(15)
 #elif defined Q_OS_OS2
-	#define OS "OS/2"
+	#define OS "OS/2"BITS
 	#define OSID quint8(16)
 #elif defined Q_OS_OPENBSD
-	#define OS "OpenBSD"
+	#define OS "OpenBSD"BITS
 	#define OSID quint8(17)
 #elif defined Q_OS_OS2EMX
-	#define OS "OS/2"
+	#define OS "OS/2"BITS
 	#define OSID quint8(18)
 #elif defined Q_OS_OSF
-	#define OS "HP Tru64 UNIX"
+	#define OS "HP Tru64 UNIX"BITS
 	#define OSID quint8(19)
 #elif defined Q_OS_QNX6
-	#define OS "QNX RTP 6.1"
+	#define OS "QNX RTP 6.1"BITS
 	#define OSID quint8(20)
 #elif defined Q_OS_QNX
-	#define OS "QNX"
+	#define OS "QNX"BITS
 	#define OSID quint8(21)
 #elif defined Q_OS_RELIANT
-	#define OS "Reliant UNIX"
+	#define OS "Reliant UNIX"BITS
 	#define OSID quint8(22)
 #elif defined Q_OS_SCO
-	#define OS "SCO OpenServer 5"
+	#define OS "SCO OpenServer 5"BITS
 	#define OSID quint8(23)
 #elif defined Q_OS_SOLARIS
-	#define OS "Sun Solaris"
+	#define OS "Sun Solaris"BITS
 	#define OSID quint8(24)
 #elif defined Q_OS_ULTRIX
-	#define OS "DEC Ultrix"
+	#define OS "DEC Ultrix"BITS
 	#define OSID quint8(25)
 #elif defined Q_OS_UNIX
-	#define OS "UNIX BSD/SYSV"
+	#define OS "UNIX BSD/SYSV"BITS
 	#define OSID quint8(26)
 #elif defined Q_OS_UNIXWARE
-	#define OS "UnixWare 7/Open UNIX 8"
+	#define OS "UnixWare 7/Open UNIX 8"BITS
 	#define OSID quint8(27)
 #elif defined Q_OS_WIN32
-	#define OS "Windows"
+	#define OS "Windows"BITS
 	#define OSID quint8(28)
 #elif defined Q_OS_WINCE
@@ -113,7 +121,7 @@
 	#define OSID quint8(29)
 #else
-	#define OS "Unknown"
+	#define OS "Unknown"BITS
 	#define OSID quint8(255)
-#endif
+#endif // OS
 
 #endif // OS_H
Index: src/tspmodel.cpp
===================================================================
--- src/tspmodel.cpp	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ src/tspmodel.cpp	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -276,10 +276,10 @@
 }
 
-void CTSPModel::saveTask(QString fname)
+bool CTSPModel::saveTask(QString fname)
 {
 QFile f(fname);
 	if (!f.open(QIODevice::WriteOnly)) {
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),QString(trUtf8("Unable to create task file.\nError: %1\nMaybe, file is read-only?")).arg(f.errorString()),QMessageBox::Ok).exec();
-		return;
+		return false;
 	}
 QDataStream ds(&f);
@@ -288,5 +288,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// File signature
@@ -295,5 +295,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// File version
@@ -302,5 +302,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// File metadata version
@@ -309,5 +309,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// Metadata
@@ -316,5 +316,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// Number of cities
@@ -323,5 +323,5 @@
 		QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 		f.close();
-		return;
+		return false;
 	}
 	// Costs
@@ -333,8 +333,9 @@
 					QMessageBox(QMessageBox::Critical,trUtf8("Task Save"),trUtf8("Unable to save task.\nError: %1").arg(f.errorString()),QMessageBox::Ok).exec();
 					f.close();
-					return;
+					return false;
 				}
 			}
 	f.close();
+	return true;
 }
 
Index: src/tspmodel.h
===================================================================
--- src/tspmodel.h	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ src/tspmodel.h	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -42,5 +42,5 @@
 	void clear();
 	void loadTask(QString);
-	void saveTask(QString);
+	bool saveTask(QString);
 	void randomize();
 signals:
Index: tspsg.pro
===================================================================
--- tspsg.pro	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ tspsg.pro	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -19,31 +19,7 @@
 	OBJECTS_DIR = release
 	DESTDIR = release
-	win32 {
-		OBJECTS_DIR = release/win32
-		DESTDIR = release/win32
-	}
-	wince* {
-		OBJECTS_DIR = release/wince
-		DESTDIR = release/wince
-	}
-	unix {
-		OBJECTS_DIR = release/nix
-		DESTDIR = release/nix
-	}
 } else {
 	OBJECTS_DIR = debug
 	DESTDIR = debug
-	win32 {
-		OBJECTS_DIR = debug/win32
-		DESTDIR = debug/win32
-	}
-	wince* {
-		OBJECTS_DIR = debug/wince
-		DESTDIR = debug/wince
-	}
-	unix {
-		OBJECTS_DIR = debug/nix
-		DESTDIR = debug/nix
-	}
 }
 
Index: ui/mainwindow.ce.ui
===================================================================
--- ui/mainwindow.ce.ui	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ ui/mainwindow.ce.ui	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -15,5 +15,5 @@
   </property>
   <property name="windowTitle">
-   <string>Travelling salesman problem</string>
+   <string>Travelling salesman problem[*]</string>
   </property>
   <property name="windowIcon">
@@ -312,4 +312,5 @@
     <addaction name="actionHelpContextual"/>
     <addaction name="separator"/>
+    <addaction name="actionHelpAboutQt"/>
     <addaction name="actionHelpAbout"/>
    </widget>
@@ -563,4 +564,22 @@
    <property name="statusTip">
     <string>Save current task</string>
+   </property>
+  </action>
+  <action name="actionHelpAboutQt">
+   <property name="icon">
+    <iconset resource="../resources/tspsg.qrc">
+     <normaloff>:/images/qtlogo-64.png</normaloff>:/images/qtlogo-64.png</iconset>
+   </property>
+   <property name="text">
+    <string>About &amp;Qt...</string>
+   </property>
+   <property name="iconText">
+    <string>About Qt...</string>
+   </property>
+   <property name="toolTip">
+    <string>About Qt</string>
+   </property>
+   <property name="statusTip">
+    <string>About Qt library</string>
    </property>
   </action>
Index: ui/mainwindow.ui
===================================================================
--- ui/mainwindow.ui	(revision 4c96f9455808960fdb0310ca72057bf926e847fb)
+++ ui/mainwindow.ui	(revision 690f6939a74b1364b999bdf013d5fc2dfd84020e)
@@ -12,5 +12,5 @@
   </property>
   <property name="windowTitle">
-   <string>Travelling salesman problem</string>
+   <string>Travelling salesman problem[*]</string>
   </property>
   <property name="windowIcon">
@@ -293,4 +293,5 @@
     <addaction name="actionHelpContextual"/>
     <addaction name="separator"/>
+    <addaction name="actionHelpAboutQt"/>
     <addaction name="actionHelpAbout"/>
    </widget>
@@ -579,4 +580,19 @@
    <property name="statusTip">
     <string>Save current task</string>
+   </property>
+  </action>
+  <action name="actionHelpAboutQt">
+   <property name="icon">
+    <iconset resource="../resources/tspsg.qrc">
+     <normaloff>:/images/qtlogo-64.png</normaloff>:/images/qtlogo-64.png</iconset>
+   </property>
+   <property name="text">
+    <string>About &amp;Qt...</string>
+   </property>
+   <property name="iconText">
+    <string>About Qt...</string>
+   </property>
+   <property name="statusTip">
+    <string>About Qt library</string>
    </property>
   </action>
